diff -ruN vdr-1.5.9/CONTRIBUTORS vdr-1.5.10/CONTRIBUTORS
--- vdr-1.5.9/CONTRIBUTORS	2007-08-26 13:13:10.000000000 +0200
+++ vdr-1.5.10/CONTRIBUTORS	2007-10-14 15:11:23.000000000 +0200
@@ -1024,6 +1024,10 @@
  for improving cControl::Launch() to keep 'control' from pointing to uninitialized
  memory
  for adding internationalization to the "skincurses" plugin
+ for helping with adding compatibility mode for playback of recordings made with
+ the subtitles plugin
+ for implementing cDevice::CloseFilter()
+ for some fixes to PLUGINS.html
 
 Ralf Klueber <ralf.klueber@vodafone.com>
  for reporting a bug in cutting a recording if there is only a single editing mark
@@ -1138,6 +1142,7 @@
  for fixing a busy loop in fast forward if the next video data file is missing
  for adding a debug error message to cReceiver::~cReceiver() in case it is still
  attached to a device
+ for reporting a missing SetVolumeDevice() call in cDevice::SetPrimaryDevice()
 
 Richard Robson <richard_robson@beeb.net>
  for reporting freezing replay if a timer starts while in Transfer Mode from the
@@ -1293,6 +1298,8 @@
 Pekka Virtanen <pekka.virtanen@sci.fi>
  for adding language code handling to the subtitling descriptor in 'libsi'
  for adding missing NULL checks when accessing sectionHandler in device.c
+ for writing the subtitle plugin, which helped in implementing subtitle handling
+ in VDR
 
 John Kennedy <rkennedy@ix.netcom.com>
  for publishing "A Fast Bresenham Algorithm For Drawing Ellipses" (found at
@@ -1419,6 +1426,10 @@
  for fixing a problem with characters >0x7F in the modified version of skipspace()
  for reporting a faulty comment in Make.config.template
  for fixing checking for ttDolbyLast in cDevice::SetCurrentAudioTrack()
+ for fixing selecting the audio track when pressing Ok in the Audio menu
+ for implementing handling DVB subtitles
+ for fixing the description of DeviceSetAvailableTrack() and cReceiver(), and adding
+ an example ~cMyReceiver() in PLUGINS.html (thanks to Marco Schlüßler).
 
 Jürgen Schmitz <j.schmitz@web.de>
  for reporting a bug in displaying the current channel when switching via the SVDRP
@@ -1522,6 +1533,8 @@
  for fixing handling single byte characters >0x7F in Utf8ToArray()
  for fixing clearing color buttons in the 'curses' skin
  for adding a missing error report to cCuttingThread::Action()
+ for reporting a problem in handling reallocated memory in cCharSetConv::Convert()
+ for fixing a new[]/delete mismatch in cMenuEditStrItem::LeaveEditMode()
 
 Sven Kreiensen <svenk@kammer.uni-hannover.de>
  for his help in keeping 'channels.conf.terr' up to date
@@ -1772,6 +1785,9 @@
  show the current APIVERSION
  for fixing i18n characters for the Hungarian texts
  for implementing using nl_langinfo(CODESET) to determine the local codeset to use
+ for removing a duplicate ',' from the ca_ES.po file
+ for suggesting to add the 'ß' character to the "allowed characters" in the
+ de_DE.po file
 
 David Woodhouse <dwmw2@infradead.org>
  for his help in replacing the get/put_unaligned() macros from asm/unaligned.h with
@@ -1878,6 +1894,8 @@
  for reporting a problem with the device selection in case of timer conflicts
  for a patch that fixed part of a crash in i18n character set conversion
  for reporting a bug in stripping the context in I18nTranslate()
+ for fixing a crash when pressing Left while at the first character of a
+ cMenuEditStrItem
 
 Thiemo Gehrke <tgehrke@reel-multimedia.com>
  for suggesting to add a setup option to turn off the automatic timeout of the
@@ -1949,6 +1967,8 @@
  for suggesting that the "Back" key should restore the original string when pressed
  while editing a string item
  for fixing detection of Premiere NVOD channel links
+ for making the default copy ctor of cRecording private
+ for a patch that was used to implement cRecording::Undelete()
 
 Jaroslaw Swierczynski <swiergot@gmail.com>
  for updating the Polish OSD texts and the fontosd-iso8859-2.c file
@@ -2169,3 +2189,24 @@
 Matthias Becker <becker.matthias@gmail.com>
  for suggesting to add a new i18n macro that can be used by plugins to mark
  texts they want to reuse from VDR's core translations
+
+Halim Sahin <halim.sahin@t-online.de>
+ for reporting that the channels.conf file was not written when stopping VDR after
+ deleting or moving a channel in the Channels menu
+
+Denis Knauf <denis.knauf@gmail.com>
+ for reporting a missing '-' at the next to last line of SVDRP help texts
+
+Diego Pierotto <vdr-italian@tiscali.it>
+ for translating OSD texts to the Italian language
+
+Timo Eskola <timo@tolleri.net>
+ for implementing sending all frames to devices that can handle them in fast forward
+ trick speeds
+
+Elias Luttinen <el@iki.fi>
+ for improving the description of where logging goes in the INSTALL file
+
+Torsten Kunkel <vdrml@tkunkel.de>
+ for pointing out that it was not obvious how to initiate internationalization
+ support for a plugin
diff -ruN vdr-1.5.9/HISTORY vdr-1.5.10/HISTORY
--- vdr-1.5.9/HISTORY	2007-08-26 13:12:48.000000000 +0200
+++ vdr-1.5.10/HISTORY	2007-10-14 15:11:00.000000000 +0200
@@ -5416,3 +5416,74 @@
   function to hand through the Level.
 - Fixed checking for ttDolbyLast in cDevice::SetCurrentAudioTrack() (thanks
   to Marco Schlüßler).
+
+2007-10-14: Version 1.5.10
+
+- Implemented handling DVB subtitles (thanks to Marco Schlüßler, and also to
+  Pekka Virtanen for writing the subtitle plugin, which helped in implementing
+  subtitle handling in VDR).
+- The new remote control key "Subtitles" can be used to bring up the list
+  of available subtitles.
+- The new setup option "DVB/Subtitle languages" can be used to define the
+  preferred languages for subtitles.
+- Fixed selecting the audio track when pressing Ok in the Audio menu (thanks
+  to Marco Schlüßler).
+- Implemented display of DVB subtitles in live viewing mode.
+- Implemented subtitle track selection.
+- Implemented bitmap color reduction and shrinking to display subtitles even
+  on devices that can't display the necessary number of colors.
+- Added compatibility mode for playback of recordings made with the subtitles
+  plugin (with some help from Rolf Ahrenberg).
+- The new setup option "DVB/Subtitle offset" can be used to shift the location
+  of the subtitles in the vertical direction.
+- The new setup options "DVB/Subtitle foreground/background transparency"
+  define an additional level of transparency for the foreground and background
+  color of subtitles.
+- Existing recordings made with the subtitle plugin can be given an 'X' record
+  in their info.vdr file, so that subtitles can be automatically selected upon
+  replay, according to the preferred language setup, as in
+  X 3 03 ger deutsch
+  (see vdr.5). Note that these entries need to be added in the proper sequence,
+  so that they correspond with the actual track languages in the recording.
+- Now generating translation files without line numbers to avoid unnecessarily
+  large diffs. Plugin authors may want to replace the -F option with
+  --no-location in the xgettext and msgmerge calls in their Makefiles.
+- Updated the Finnish OSD texts (thanks to Rolf Ahrenberg).
+- Added a missing Channels.SetModified(true) call when deleting or moving a
+  channel in the Channels menu (reported by Halim Sahin).
+- Fixed a missing '-' at the next to last line of SVDRP help texts (reported by
+  Denis Knauf).
+- Added a missing SetVolumeDevice() call in cDevice::SetPrimaryDevice() (reported
+  by Reinhard Nissl).
+- Fixed a crash when pressing Left while at the first character of a cMenuEditStrItem
+  (thanks to Christian Wieninger).
+- Only creating a new cDvbOsdProvider in cDvbDevice::MakePrimaryDevice() if 'On'
+  is true (i.e. this device is being made the primary device).
+- Updated the Italian OSD texts (thanks to Diego Pierotto).
+- Fixed handling reallocated memory in cCharSetConv::Convert() (reported by Udo
+  Richter).
+- Fixed a new[]/delete mismatch in cMenuEditStrItem::LeaveEditMode() (thanks to
+  Udo Richter).
+- Implemented sending all frames to devices that can handle them in fast forward
+  trick speeds (thansk to Timo Eskola).
+- Updated the Hungarian language texts (thanks to Thomas Günther).
+- Fixed description of DeviceSetAvailableTrack() and cReceiver(), and added an
+  example ~cMyReceiver() in PLUGINS.html (thanks to Marco Schlüßler).
+- Improved the description of where logging goes in the INSTALL file (thanks to
+  Elias Luttinen).
+- Added a note about how to initiate internationalization support to the
+  README.i18n file. The Makefile generated by the 'newplugin' script now has the
+  'i18n' target automatically create an initial 'po/pluginname.pot' file.
+  Plugin authors may want to add the '$(I18Npot)' dependency to the 'i18n'
+  target in their Makefiles, as in
+  i18n: $(I18Npot) $(I18Nmo)
+  (based on a suggestion by Torsten Kunkel).
+- Removed a duplicate ',' from the ca_ES.po file (thanks to Thomas Günther).
+- Added the 'ß' character to the "allowed charcaters" in the de_DE.po file
+  (suggested by Thomas Günther).
+- Made the default copy ctor of cRecording private (thanks to Markus Hahn).
+  Same for the assign operator.
+- Added cRecording::Undelete() (based on a patch from Markus Hahn).
+- Added cDevice::CloseFilter() to allow a device to have complete control over
+  both opening and closing section filters (thanks to Rolf Ahrenberg).
+- Some fixes to PLUGINS.html (thanks to Rolf Ahrenberg).
diff -ruN vdr-1.5.9/INSTALL vdr-1.5.10/INSTALL
--- vdr-1.5.9/INSTALL	2007-08-24 15:11:58.000000000 +0200
+++ vdr-1.5.10/INSTALL	2007-10-13 15:01:06.000000000 +0200
@@ -66,8 +66,9 @@
 line option '--vfat'.
 
 When running, the 'vdr' program writes status information into the
-system log file (/var/log/messages). You may want to watch these
-messages (tail -f /var/log/mesages) to see if there are any problems.
+system log file, which is usually /var/log/messages (or /var/log/user.log,
+depending on your syslog configuration). You may want to watch these
+messages (tail -f /var/log/messages) to see if there are any problems.
 
 The program can be controlled via a network connection to its SVDRP
 port ("Simple Video Disk Recorder Protocol"). By default, it listens
diff -ruN vdr-1.5.9/MANUAL vdr-1.5.10/MANUAL
--- vdr-1.5.9/MANUAL	2007-06-23 11:28:05.000000000 +0200
+++ vdr-1.5.10/MANUAL	2007-10-06 16:28:53.000000000 +0200
@@ -59,6 +59,7 @@
   Mute        mute
 
   Audio       select audio track
+  Subtitles   select subtitles
 
   Schedule    \
   Channels    |
@@ -675,6 +676,31 @@
                          many "Audio language" options which allow you to select the
                          individual preferred languages.
 
+  Display subtitles = no If set to 'yes', the first available subtitles in the list
+                         of preferred subtitle languages will be turned on when
+                         switching to a channel that provides subtitles.
+
+  Subtitle languages = 0 Some tv stations broadcast various subtitle tracks in different
+                         languages. This option allows you to define which language(s)
+                         you prefer in such cases. By default, or if none of the
+                         preferred languages is broadcast, no subtitles will
+                         be selected when switching to such a channel. If this option
+                         is set to a non-zero value, the menu page will contain that
+                         many "Subtitle language" options which allow you to select the
+                         individual preferred languages.
+
+  Subtitle offset = 0    Allows you to shift the location of the subtitles in the
+                         vertical direction. The valid range is -50...50. This option
+                         is only avialable if "Display subtitles" is set to 'yes'.
+
+  Subtitle foreground transparency = 0
+  Subtitle background transparency = 0
+                         These define an additional level of transparency for the
+                         foreground and background color of subtitles. Valid ranges
+                         are 0...9 for foreground transparency, and 0...10 for
+                         background transparency. By default the values as broadcast
+                         are used.
+
   LNB:
 
   SLOF               = 11700  The switching frequency (in MHz) between low and
diff -ruN vdr-1.5.9/Makefile vdr-1.5.10/Makefile
--- vdr-1.5.9/Makefile	2007-08-25 10:52:17.000000000 +0200
+++ vdr-1.5.10/Makefile	2007-10-13 11:26:40.000000000 +0200
@@ -4,7 +4,7 @@
 # See the main source file 'vdr.c' for copyright information and
 # how to reach the author.
 #
-# $Id: Makefile 1.106 2007/08/25 08:52:17 kls Exp $
+# $Id: Makefile 1.108 2007/10/13 09:26:40 kls Exp $
 
 .DELETE_ON_ERROR:
 
@@ -37,7 +37,7 @@
 SILIB    = $(LSIDIR)/libsi.a
 
 OBJS = audio.o channels.o ci.o config.o cutter.o device.o diseqc.o dvbdevice.o dvbci.o dvbosd.o\
-       dvbplayer.o dvbspu.o eit.o eitscan.o epg.o filter.o font.o i18n.o interface.o keys.o\
+       dvbplayer.o dvbspu.o dvbsubtitle.o eit.o eitscan.o epg.o filter.o font.o i18n.o interface.o keys.o\
        lirc.o menu.o menuitems.o nit.o osdbase.o osd.o pat.o player.o plugin.o rcu.o\
        receiver.o recorder.o recording.o remote.o remux.o ringbuffer.o sdt.o sections.o shutdown.o\
        skinclassic.o skins.o skinsttng.o sources.o spu.o status.o svdrp.o themes.o thread.o\
@@ -114,10 +114,10 @@
 	msgfmt -c -o $@ $<
 
 $(I18Npot): $(wildcard *.c)
-	xgettext -C -cTRANSLATORS --no-wrap -F -k -ktr -ktrNOOP --msgid-bugs-address='<vdr-bugs@cadsoft.de>' -o $@ $(wildcard *.c)
+	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --msgid-bugs-address='<vdr-bugs@cadsoft.de>' -o $@ $(wildcard *.c)
 
 $(I18Npo): $(I18Npot)
-	msgmerge -U --no-wrap -F --backup=none -q $@ $<
+	msgmerge -U --no-wrap --no-location --backup=none -q $@ $<
 
 i18n: $(I18Nmo)
 	@mkdir -p $(LOCALEDIR)
diff -ruN vdr-1.5.9/PLUGINS/src/hello/Makefile vdr-1.5.10/PLUGINS/src/hello/Makefile
--- vdr-1.5.9/PLUGINS/src/hello/Makefile	2007-08-19 16:18:59.000000000 +0200
+++ vdr-1.5.10/PLUGINS/src/hello/Makefile	2007-10-14 11:23:04.000000000 +0200
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 1.18 2007/08/19 14:18:59 kls Exp $
+# $Id: Makefile 1.20 2007/10/14 09:23:04 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -80,12 +80,12 @@
 	msgfmt -c -o $@ $<
 
 $(I18Npot): $(wildcard *.c)
-	xgettext -C -cTRANSLATORS --no-wrap -F -k -ktr -ktrNOOP --msgid-bugs-address='<vdr-bugs@cadsoft.de>' -o $@ $(wildcard *.c)
+	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --msgid-bugs-address='<vdr-bugs@cadsoft.de>' -o $@ $(wildcard *.c)
 
 $(I18Npo): $(I18Npot)
-	msgmerge -U --no-wrap -F --backup=none -q $@ $<
+	msgmerge -U --no-wrap --no-location --backup=none -q $@ $<
 
-i18n: $(I18Nmo)
+i18n: $(I18Npot) $(I18Nmo)
 	@mkdir -p $(LOCALEDIR)
 	for i in $(I18Ndirs); do\
 	    mkdir -p $(LOCALEDIR)/$$i/LC_MESSAGES;\
diff -ruN vdr-1.5.9/PLUGINS/src/skincurses/HISTORY vdr-1.5.10/PLUGINS/src/skincurses/HISTORY
--- vdr-1.5.9/PLUGINS/src/skincurses/HISTORY	2007-08-15 15:58:21.000000000 +0200
+++ vdr-1.5.10/PLUGINS/src/skincurses/HISTORY	2007-08-26 22:36:59.000000000 +0200
@@ -57,3 +57,7 @@
 - Moved the "all" target in the Makefile before the "Implicit rules",
   so that a plain "make" will compile everything.
 - Added internationalization.
+
+2007-08-26: Version 0.1.4
+
+- Adapted to the new Level parameter of cOsd.
diff -ruN vdr-1.5.9/PLUGINS/src/skincurses/Makefile vdr-1.5.10/PLUGINS/src/skincurses/Makefile
--- vdr-1.5.9/PLUGINS/src/skincurses/Makefile	2007-08-19 16:19:07.000000000 +0200
+++ vdr-1.5.10/PLUGINS/src/skincurses/Makefile	2007-10-14 11:23:25.000000000 +0200
@@ -1,7 +1,7 @@
 #
 # Makefile for a Video Disk Recorder plugin
 #
-# $Id: Makefile 1.11 2007/08/19 14:19:07 kls Exp $
+# $Id: Makefile 1.13 2007/10/14 09:23:25 kls Exp $
 
 # The official name of this plugin.
 # This name will be used in the '-P...' option of VDR to load the plugin.
@@ -78,12 +78,12 @@
 	msgfmt -c -o $@ $<
 
 $(I18Npot): $(wildcard *.c)
-	xgettext -C -cTRANSLATORS --no-wrap -F -k -ktr -ktrNOOP --msgid-bugs-address='<vdr-bugs@cadsoft.de>' -o $@ $(wildcard *.c)
+	xgettext -C -cTRANSLATORS --no-wrap --no-location -k -ktr -ktrNOOP --msgid-bugs-address='<vdr-bugs@cadsoft.de>' -o $@ $(wildcard *.c)
 
 $(I18Npo): $(I18Npot)
-	msgmerge -U --no-wrap -F --backup=none -q $@ $<
+	msgmerge -U --no-wrap --no-location --backup=none -q $@ $<
 
-i18n: $(I18Nmo)
+i18n: $(I18Npot) $(I18Nmo)
 	@mkdir -p $(LOCALEDIR)
 	for i in $(I18Ndirs); do\
 	    mkdir -p $(LOCALEDIR)/$$i/LC_MESSAGES;\
diff -ruN vdr-1.5.9/PLUGINS/src/skincurses/skincurses.c vdr-1.5.10/PLUGINS/src/skincurses/skincurses.c
--- vdr-1.5.9/PLUGINS/src/skincurses/skincurses.c	2007-08-15 16:01:54.000000000 +0200
+++ vdr-1.5.10/PLUGINS/src/skincurses/skincurses.c	2007-08-26 22:16:59.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: skincurses.c 1.17 2007/08/15 14:01:54 kls Exp $
+ * $Id: skincurses.c 1.18 2007/08/26 20:16:59 kls Exp $
  */
 
 #include <ncurses.h>
@@ -11,7 +11,7 @@
 #include <vdr/plugin.h>
 #include <vdr/skins.h>
 
-static const char *VERSION        = "0.1.3";
+static const char *VERSION        = "0.1.4";
 static const char *DESCRIPTION    = trNOOP("A text only skin");
 static const char *MAINMENUENTRY  = NULL;
 
@@ -72,7 +72,7 @@
   };
 
 cCursesOsd::cCursesOsd(int Left, int Top)
-:cOsd(Left, Top)
+:cOsd(Left, Top, 0)
 {
   savedRegion = NULL;
 
diff -ruN vdr-1.5.9/README.i18n vdr-1.5.10/README.i18n
--- vdr-1.5.9/README.i18n	2007-08-11 13:28:42.000000000 +0200
+++ vdr-1.5.10/README.i18n	2007-10-14 11:16:14.000000000 +0200
@@ -7,6 +7,19 @@
 plugin.
 
 
+How to initiate internationalization support
+--------------------------------------------
+
+Not every plugin necessarily has texts that are visible to the
+user, therefore there is by default no 'po' directory.
+If your plugin source contains texts marked for translation
+with tr(), you need to
+
+- Change into the source directory.
+- Enter the command 'mkdir po'.
+
+After that, continue with "How to translate to a new language".
+
 How to translate to a new language
 ----------------------------------
 
@@ -18,15 +31,16 @@
   will create a new *.po file for your language.
 - Edit the new *.po file and translate the texts.
   You can do this either with your favorite text editor, or
-  with a specialited tool like POEdit, GTranslator, KBabel
+  with a specialized tool like POEdit, GTranslator, KBabel
   or whatever you have.
 
 How to maintain an existing language file
 -----------------------------------------
 
+- Change into the source directory.
 - Do a 'make i18n' to have the *.po files brought up-to-date
   with the texts in the source code.
-- Edit the new *.po file and translate the texts.
+- Edit the modified *.po file(s) and translate the texts.
   If you are using a plain text editor, you should search for
   empty strings ("") to find new, untranslated texts. Also,
   look for the "fuzzy" keyword to find translations that have
diff -ruN vdr-1.5.9/channels.c vdr-1.5.10/channels.c
--- vdr-1.5.9/channels.c	2007-07-21 16:55:01.000000000 +0200
+++ vdr-1.5.10/channels.c	2007-10-12 16:40:53.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.c 1.54 2007/07/21 14:55:01 kls Exp $
+ * $Id: channels.c 1.55 2007/10/12 14:40:53 kls Exp $
  */
 
 #include "channels.h"
@@ -440,12 +440,12 @@
   return q - s;
 }
 
-void cChannel::SetPids(int Vpid, int Ppid, int *Apids, char ALangs[][MAXLANGCODE2], int *Dpids, char DLangs[][MAXLANGCODE2], int Tpid)
+void cChannel::SetPids(int Vpid, int Ppid, int *Apids, char ALangs[][MAXLANGCODE2], int *Dpids, char DLangs[][MAXLANGCODE2], int *Spids, char SLangs[][MAXLANGCODE2], int Tpid)
 {
   int mod = CHANNELMOD_NONE;
   if (vpid != Vpid || ppid != Ppid || tpid != Tpid)
      mod |= CHANNELMOD_PIDS;
-  int m = IntArraysDiffer(apids, Apids, alangs, ALangs) | IntArraysDiffer(dpids, Dpids, dlangs, DLangs);
+  int m = IntArraysDiffer(apids, Apids, alangs, ALangs) | IntArraysDiffer(dpids, Dpids, dlangs, DLangs) | IntArraysDiffer(spids, Spids, slangs, SLangs);
   if (m & STRDIFF)
      mod |= CHANNELMOD_LANGS;
   if (m & VALDIFF)
@@ -468,7 +468,16 @@
         q += IntArrayToString(q, Dpids, 10, DLangs);
         }
      *q = 0;
-     dsyslog("changing pids of channel %d from %d+%d:%s:%d to %d+%d:%s:%d", Number(), vpid, ppid, OldApidsBuf, tpid, Vpid, Ppid, NewApidsBuf, Tpid);
+     const int SBufferSize = MAXSPIDS * (5 + 1 + MAXLANGCODE2) + 10; // 5 digits plus delimiting ',' or ';' plus optional '=cod', +10: paranoia
+     char OldSpidsBuf[SBufferSize];
+     char NewSpidsBuf[SBufferSize];
+     q = OldSpidsBuf;
+     q += IntArrayToString(q, spids, 10, slangs);
+     *q = 0;
+     q = NewSpidsBuf;
+     q += IntArrayToString(q, Spids, 10, SLangs);
+     *q = 0;
+     dsyslog("changing pids of channel %d from %d+%d:%s:%s:%d to %d+%d:%s:%s:%d", Number(), vpid, ppid, OldApidsBuf, OldSpidsBuf, tpid, Vpid, Ppid, NewApidsBuf, NewSpidsBuf, Tpid);
      vpid = Vpid;
      ppid = Ppid;
      for (int i = 0; i < MAXAPIDS; i++) {
@@ -481,6 +490,11 @@
          strn0cpy(dlangs[i], DLangs[i], MAXLANGCODE2);
          }
      dpids[MAXDPIDS] = 0;
+     for (int i = 0; i < MAXSPIDS; i++) {
+         spids[i] = Spids[i];
+         strn0cpy(slangs[i], SLangs[i], MAXLANGCODE2);
+         }
+     spids[MAXSPIDS] = 0;
      tpid = Tpid;
      modification |= mod;
      Channels.SetModified();
diff -ruN vdr-1.5.9/channels.h vdr-1.5.10/channels.h
--- vdr-1.5.9/channels.h	2007-07-21 16:58:36.000000000 +0200
+++ vdr-1.5.10/channels.h	2007-09-02 12:23:11.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.h 1.44 2007/07/21 14:58:36 kls Exp $
+ * $Id: channels.h 1.45 2007/09/02 10:23:11 kls Exp $
  */
 
 #ifndef __CHANNELS_H
@@ -33,7 +33,7 @@
 
 #define MAXAPIDS 32 // audio
 #define MAXDPIDS 16 // dolby (AC3 + DTS)
-#define MAXSPIDS  8 // subtitles
+#define MAXSPIDS 32 // subtitles
 #define MAXCAIDS  8 // conditional access
 
 #define MAXLANGCODE1 4 // a 3 letter language code, zero terminated
@@ -212,7 +212,7 @@
   void SetId(int Nid, int Tid, int Sid, int Rid = 0);
   void SetName(const char *Name, const char *ShortName, const char *Provider);
   void SetPortalName(const char *PortalName);
-  void SetPids(int Vpid, int Ppid, int *Apids, char ALangs[][MAXLANGCODE2], int *Dpids, char DLangs[][MAXLANGCODE2], int Tpid);
+  void SetPids(int Vpid, int Ppid, int *Apids, char ALangs[][MAXLANGCODE2], int *Dpids, char DLangs[][MAXLANGCODE2], int *Spids, char SLangs[][MAXLANGCODE2], int Tpid);
   void SetCaIds(const int *CaIds); // list must be zero-terminated
   void SetCaDescriptors(int Level);
   void SetLinkChannels(cLinkChannels *LinkChannels);
diff -ruN vdr-1.5.9/config.c vdr-1.5.10/config.c
--- vdr-1.5.9/config.c	2007-08-12 14:09:37.000000000 +0200
+++ vdr-1.5.10/config.c	2007-10-06 16:28:58.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.c 1.156 2007/08/12 12:09:37 kls Exp $
+ * $Id: config.c 1.157 2007/10/06 14:28:58 kls Exp $
  */
 
 #include "config.h"
@@ -236,6 +236,11 @@
   MarginStart = 2;
   MarginStop = 10;
   AudioLanguages[0] = -1;
+  DisplaySubtitles = 0;
+  SubtitleLanguages[0] = -1;
+  SubtitleOffset = 0;
+  SubtitleFgTransparency = 0;
+  SubtitleBgTransparency = 0;
   EPGLanguages[0] = -1;
   EPGScanTimeout = 5;
   EPGBugfixLevel = 3;
@@ -406,6 +411,11 @@
   else if (!strcasecmp(Name, "MarginStart"))         MarginStart        = atoi(Value);
   else if (!strcasecmp(Name, "MarginStop"))          MarginStop         = atoi(Value);
   else if (!strcasecmp(Name, "AudioLanguages"))      return ParseLanguages(Value, AudioLanguages);
+  else if (!strcasecmp(Name, "DisplaySubtitles"))    DisplaySubtitles   = atoi(Value);
+  else if (!strcasecmp(Name, "SubtitleLanguages"))   return ParseLanguages(Value, SubtitleLanguages);
+  else if (!strcasecmp(Name, "SubtitleOffset"))      SubtitleOffset     = atoi(Value);
+  else if (!strcasecmp(Name, "SubtitleFgTransparency")) SubtitleFgTransparency = atoi(Value);
+  else if (!strcasecmp(Name, "SubtitleBgTransparency")) SubtitleBgTransparency = atoi(Value);
   else if (!strcasecmp(Name, "EPGLanguages"))        return ParseLanguages(Value, EPGLanguages);
   else if (!strcasecmp(Name, "EPGScanTimeout"))      EPGScanTimeout     = atoi(Value);
   else if (!strcasecmp(Name, "EPGBugfixLevel"))      EPGBugfixLevel     = atoi(Value);
@@ -483,6 +493,11 @@
   Store("MarginStart",        MarginStart);
   Store("MarginStop",         MarginStop);
   StoreLanguages("AudioLanguages", AudioLanguages);
+  Store("DisplaySubtitles",   DisplaySubtitles);
+  StoreLanguages("SubtitleLanguages", SubtitleLanguages);
+  Store("SubtitleOffset",     SubtitleOffset);
+  Store("SubtitleFgTransparency", SubtitleFgTransparency);
+  Store("SubtitleBgTransparency", SubtitleBgTransparency);
   StoreLanguages("EPGLanguages", EPGLanguages);
   Store("EPGScanTimeout",     EPGScanTimeout);
   Store("EPGBugfixLevel",     EPGBugfixLevel);
diff -ruN vdr-1.5.9/config.h vdr-1.5.10/config.h
--- vdr-1.5.9/config.h	2007-08-19 18:02:50.000000000 +0200
+++ vdr-1.5.10/config.h	2007-10-06 16:27:18.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 1.298 2007/08/19 16:02:50 kls Exp $
+ * $Id: config.h 1.299 2007/10/06 14:27:18 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.5.9"
-#define VDRVERSNUM   10509  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.5.10"
+#define VDRVERSNUM   10510  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.5.9"
-#define APIVERSNUM   10509  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.5.10"
+#define APIVERSNUM   10510  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
@@ -220,6 +220,10 @@
   int TimeTransponder;
   int MarginStart, MarginStop;
   int AudioLanguages[I18N_MAX_LANGUAGES + 1];
+  int DisplaySubtitles;
+  int SubtitleLanguages[I18N_MAX_LANGUAGES + 1];
+  int SubtitleOffset;
+  int SubtitleFgTransparency, SubtitleBgTransparency;
   int EPGLanguages[I18N_MAX_LANGUAGES + 1];
   int EPGScanTimeout;
   int EPGBugfixLevel;
